/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOTRANSP                                               */
/* Tabela : TIPOTRANSP                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 06/04/2004 - Raphael Freitas Pinheiro                                      */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPOTRANSP
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOTRANSP FOR EACH ROW
 
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPTR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPTRANS,0) <> NVL(:NEW.CDTIPTRANS,0)) OR
         (NVL(:OLD.NMTIPTRANS,0) <> NVL(:NEW.NMTIPTRANS,0)) THEN
         :NEW.DTULTATUTPTR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOTRANSP','', 'CDTIPTRANS='||:OLD.CDTIPTRANS||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOTRANSP MODIFY DTULTATUTPTR DEFAULT SYSDATE
/

