 -- ====================================================================
--
--
--
-- @C:\Web_503\Sql\End_Conv\Oracle\3998_ESTFUNO_CUSTO_LANCAMENTO.SQL
-- raise_application_error(-20501, P_VRCUSTOLANC||':'||P_QTDELANCTO , True);
-- ====================================================================
CREATE OR REPLACE PROCEDURE CUSTO_LANCAMENTO(
   P_FILIMOVI     IN ITLANCTOEST.CDFILIMOVI%TYPE,
   P_DATALANC     IN ITLANCTOEST.DTLANCMOVI%TYPE,
   P_CDALMOXARIFE IN ITLANCTOEST.CDALMOXARIFE%TYPE,
   P_CDLOCALESTOQ IN ITLANCTOEST.CDLOCALESTOQ%TYPE,
   P_NRLOTEESTQ   IN ITLANCTOEST.NRLOTEESTQ%TYPE,
   P_NRSUBLOTE    IN ITLANCTOEST.NRSUBLOTE%TYPE,
   P_CDPRODUTO    IN ITLANCTOEST.CDPRODUTO%TYPE,
   P_FILILANCTO   IN ITLANCTOEST.CDFILIAL%TYPE,
   P_IDTIPOMOVI   IN ITLANCTOEST.IDTIPOMOVI%TYPE,
   P_VRCUSTOLANC  OUT NUMBER,
   P_VRCUSTLANCBR OUT NUMBER,
   P_QTDELANCTO   OUT NUMBER )
AS

BEGIN

   DECLARE

      V_QTDEESTO      NUMBER;
      V_VALRESTO      NUMBER;
      V_VALRBRUT      NUMBER;
      V_QTDEANTE      NUMBER;
      V_VRESTANT      NUMBER;
      V_VRBRUANT      NUMBER;
      V_QTDEESTOPOS   NUMBER;
      V_VALRESTOPOS   NUMBER;
      V_VALRBRUTPOS   NUMBER;
      V_QTDEANTEPOS   NUMBER;
      V_VRESTANTPOS   NUMBER;
      V_VRBRUANTPOS   NUMBER;
      V_TIPCUSTEST    NUMBER;

      V_CUSTPROD      NUMBER;

      V_DTAUXILIAR    DATE;

      w_S                      CHAR(1) := 'S';
      w_N                      CHAR(1) := 'N';

   BEGIN

      Begin
         SELECT NVL(TO_NUMBER(CDTIPCUSTEST),3)
         INTO V_TIPCUSTEST
         FROM PARAMFILIAL
         WHERE CDFILIAL = P_FILIMOVI;
      Exception
           WHEN NO_DATA_FOUND THEN
              V_TIPCUSTEST := 3;
      End;


      /* LER SALDO INICIAL DO PRODUTO */

      BEGIN
        SELECT ROUND(NVL(QTESTOQDIA,   0), 5),
               ROUND(NVL(VRESTOQDIA,   0), 5),
               ROUND(NVL(VRESTOQBRUT,  0), 5),
               ROUND(NVL(QTESTOQANT,   0), 5),
               ROUND(NVL(VRESTOQANT,   0), 5),
               ROUND(NVL(VRBRUTOANT,   0), 5),
               DTPOSIESTQ
        INTO   V_QTDEESTOPOS,
               V_VALRESTOPOS,
               V_VALRBRUTPOS,
               V_QTDEANTEPOS,
               V_VRESTANTPOS,
               V_VRBRUANTPOS,
               V_DTAUXILIAR
        FROM POSESTDIA
        WHERE (CDFILIAL     = P_FILIMOVI)          AND
              (CDALMOXARIFE = P_CDALMOXARIFE)      AND
              (CDLOCALESTOQ = P_CDLOCALESTOQ)      AND
              (NRLOTEESTQ   = P_NRLOTEESTQ)        AND
              (NRSUBLOTE    = P_NRSUBLOTE)         AND
              (CDPRODUTO    = P_CDPRODUTO)         AND
              (DTPOSIESTQ   = DTPOSICAO_POSESTDIA(P_FILIMOVI, P_CDPRODUTO, P_CDALMOXARIFE, P_CDLOCALESTOQ, P_NRLOTEESTQ, P_NRSUBLOTE, P_DATALANC+1));
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
             V_QTDEESTOPOS    := 0;
             V_VALRESTOPOS    := 0;
             V_VALRBRUTPOS    := 0;
             V_QTDEANTEPOS    := 0;
             V_VRESTANTPOS    := 0;
             V_VRBRUANTPOS    := 0;
             V_DTAUXILIAR     := Null;
      END;

      IF TO_DATE(P_DATALANC+1) <> V_DTAUXILIAR THEN
         V_QTDEESTO   := V_QTDEESTOPOS;
         V_VALRESTO   := V_VALRESTOPOS;
         V_VALRBRUT   := V_VALRBRUTPOS;

         V_QTDEANTE   := V_QTDEANTEPOS;
         V_VRESTANT   := V_VRESTANTPOS;
         V_VRBRUANT   := V_VRBRUANTPOS;
      ELSE

         V_QTDEESTO   := V_QTDEANTEPOS;
         V_VALRESTO   := V_VRESTANTPOS;
         V_VALRBRUT   := V_VRBRUANTPOS;

         V_QTDEANTE   := V_QTDEANTEPOS;
         V_VRESTANT   := V_VRESTANTPOS;
         V_VRBRUANT   := V_VRBRUANTPOS;
      END IF;



      IF (V_QTDEESTO <> 0) THEN
         V_QTDEANTE   := V_QTDEANTEPOS;
         V_VRESTANT   := V_VRESTANTPOS;
         V_VRBRUANT   := V_VRBRUANTPOS;
      END IF;

      P_VRCUSTOLANC  := 0;
      P_QTDELANCTO   := 0;
      P_VRCUSTLANCBR := 0;
      FOR C_LANCTOEST IN (SELECT IDTIPOMOVI, DTLANCMOVI, NVL(VRLANCTOEST,0) VRLANCTOEST,
                                 NVL(VRLANCTOBRUT, 0) VRLANCTOBRUT, QTLANCTOEST, IDALTCMEDMV,
                                 CDFILIAL, NRLANCESTQ, NRSEQUITEM, IDORDEMCLC
                          FROM ITLANCTOEST
                          WHERE (CDFILIMOVI   = P_FILIMOVI)     AND
                                (CDALMOXARIFE = P_CDALMOXARIFE) AND
                                (CDLOCALESTOQ = P_CDLOCALESTOQ) AND
                                (NRLOTEESTQ   = P_NRLOTEESTQ)   AND
                                (NRSUBLOTE    = P_NRSUBLOTE)    AND
                                (CDPRODMOVI   = P_CDPRODUTO)    AND
                                (DTLANCMOVI   = P_DATALANC)     AND
                                (NVL(IDEVOLESTOQ,w_S) = w_S)
                          ORDER BY DTLANCMOVI, NVL(IDORDEMCLC,IDTIPOMOVI), NRLANCESTQ, NRSEQUITEM) LOOP
         IF (V_QTDEESTO <> 0) THEN
            V_QTDEANTE   := V_QTDEESTO;
            V_VRESTANT   := V_VALRESTO;
            V_VRBRUANT   := V_VALRBRUT;

         END IF;
         /* TRATAMENTO PARA CADA REGISTRO DE LANAMENTO DE ESTOQUE */

         IF (C_LANCTOEST.IDTIPOMOVI = '0') THEN    /* IMPLANTAO */

            P_QTDELANCTO   := C_LANCTOEST.QTLANCTOEST  - V_QTDEESTO;
            P_VRCUSTOLANC  := C_LANCTOEST.VRLANCTOEST  - V_VALRESTO;
            P_VRCUSTLANCBR := C_LANCTOEST.VRLANCTOBRUT - V_VALRBRUT;

            V_VALRBRUT    := C_LANCTOEST.VRLANCTOBRUT;
            V_VALRESTO    := C_LANCTOEST.VRLANCTOEST;
            V_QTDEESTO    := C_LANCTOEST.QTLANCTOEST;
         ELSIF (C_LANCTOEST.IDTIPOMOVI = '1') THEN    /* AJUSTES     */
            V_CUSTPROD := CUSTO_PRODUTO_LCEST(P_FILIMOVI, P_CDPRODUTO, V_TIPCUSTEST, P_DATALANC, P_DATALANC,
                                              P_CDALMOXARIFE, P_CDLOCALESTOQ, P_NRLOTEESTQ, P_NRSUBLOTE);


            IF V_QTDEESTO <> 0 THEN

               V_VALRBRUT := V_VALRBRUT - ((V_VALRBRUT/V_QTDEESTO)* (V_QTDEESTO - C_LANCTOEST.QTLANCTOEST));
               V_VALRESTO := V_VALRESTO - ((V_VALRESTO/V_QTDEESTO)* (V_QTDEESTO - C_LANCTOEST.QTLANCTOEST));
            ELSE
               IF (V_QTDEESTOPOS <> 0) THEN
                  V_VALRBRUT := ((V_VALRBRUT/V_QTDEESTOPOS)* C_LANCTOEST.QTLANCTOEST);
                  V_VALRESTO := ((V_VALRESTOPOS/V_QTDEESTOPOS)* C_LANCTOEST.QTLANCTOEST);
               ELSE
                  V_VALRBRUT := 0;
                  V_VALRESTO := 0;
               END IF;
            END IF;

            IF   NVL(C_LANCTOEST.IDORDEMCLC, C_LANCTOEST.IDTIPOMOVI) = '0' THEN
               P_QTDELANCTO   := C_LANCTOEST.QTLANCTOEST  - V_QTDEESTO;
               P_VRCUSTOLANC  := (C_LANCTOEST.QTLANCTOEST  - V_QTDEESTO) * V_CUSTPROD;
               P_VRCUSTLANCBR := (C_LANCTOEST.QTLANCTOEST  - V_QTDEESTO) * V_CUSTPROD;
            ELSE
               P_QTDELANCTO   := C_LANCTOEST.QTLANCTOEST;
               P_VRCUSTOLANC  := V_VALRESTO;
               P_VRCUSTLANCBR := V_VALRBRUT;
            END IF;

            V_QTDEESTO := C_LANCTOEST.QTLANCTOEST;

         ELSIF (C_LANCTOEST.IDTIPOMOVI = '2') THEN    /* ENTRADA */

            V_QTDEESTO     := V_QTDEESTO   +  C_LANCTOEST.QTLANCTOEST;

            IF C_LANCTOEST.QTLANCTOEST = 0 THEN
               V_VALRBRUT := V_VALRBRUT + C_LANCTOEST.VRLANCTOBRUT;
               V_VALRESTO := V_VALRESTO + C_LANCTOEST.VRLANCTOEST;
            ELSE
               V_VALRBRUT := V_VALRBRUT + (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOBRUT);
               V_VALRESTO := V_VALRESTO + (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOEST);
            END IF;

            IF V_QTDEESTO  = 0 THEN
               V_VALRBRUT   := 0;
               V_VALRESTO   := 0;
            END IF;

            P_VRCUSTOLANC  := C_LANCTOEST.VRLANCTOEST;
            P_QTDELANCTO   := C_LANCTOEST.QTLANCTOEST;
            P_VRCUSTLANCBR := C_LANCTOEST.VRLANCTOBRUT;

         ELSIF (C_LANCTOEST.IDTIPOMOVI = '3') THEN    /* RETIRADA    */
            IF V_QTDEESTO > 0 THEN
               V_VALRBRUT := V_VALRBRUT - ((V_VALRBRUT/V_QTDEESTO)*C_LANCTOEST.QTLANCTOEST);
               V_VALRESTO := V_VALRESTO - ((V_VALRESTO/V_QTDEESTO)*C_LANCTOEST.QTLANCTOEST);

            END IF;

            V_QTDEESTO := V_QTDEESTO - C_LANCTOEST.QTLANCTOEST;

            IF (V_QTDEESTO < 0) THEN
               IF (V_QTDEANTE <> 0) THEN
                  V_VALRESTO := ((V_VRESTANT/V_QTDEANTE)*V_QTDEESTO);
                  V_VALRBRUT := ((V_VRBRUANT/V_QTDEANTE)*V_QTDEESTO);
               ELSE
                  V_VALRESTO := 0;
                  V_VALRBRUT := 0;
               END IF;
            END IF;

            IF ROUND(V_QTDEESTO,3) = 0 THEN
               V_QTDEESTO := 0;
            END IF;

            IF V_QTDEESTO  = 0 THEN
               V_VALRBRUT   := 0;
               V_VALRESTO   := 0;
            END IF;
         ELSIF (C_LANCTOEST.IDTIPOMOVI = '4') THEN    /* SADA       */

            IF V_QTDEESTO > 0 THEN
               V_VALRBRUT   := V_VALRBRUT - ((V_VALRBRUT/V_QTDEESTO)*C_LANCTOEST.QTLANCTOEST);
               V_VALRESTO   := V_VALRESTO - ((V_VALRESTO/V_QTDEESTO)*C_LANCTOEST.QTLANCTOEST);
            END IF;

            V_QTDEESTO := V_QTDEESTO - C_LANCTOEST.QTLANCTOEST;

            IF (V_QTDEESTO < 0) THEN
               IF (V_QTDEANTE <> 0) THEN
                  V_VALRESTO := ((V_VRESTANT/V_QTDEANTE)*V_QTDEESTO);
                  V_VALRBRUT := ((V_VRBRUANT/V_QTDEANTE)*V_QTDEESTO);
               ELSE
                  V_VALRESTO := 0;
                  V_VALRBRUT := 0;
               END IF;
            END IF;

            IF ROUND(V_QTDEESTO,3) = 0 THEN
               V_QTDEESTO := 0;
            END IF;

            IF V_QTDEESTO  = 0 THEN
               V_VALRBRUT   := 0;
               V_VALRESTO   := 0;
            END IF;
            
         ELSIF (C_LANCTOEST.IDTIPOMOVI = '5') THEN    /* DEV. FORN.  */
            IF C_LANCTOEST.QTLANCTOEST = 0 THEN
               V_VALRBRUT := V_VALRBRUT - C_LANCTOEST.VRLANCTOBRUT;
               V_VALRESTO := V_VALRESTO - C_LANCTOEST.VRLANCTOEST;
            ELSE
               /*Bruto*/
               V_CUSTPROD := 0;
               IF V_QTDEESTO <> 0 THEN
                  V_CUSTPROD   := V_VALRBRUT / V_QTDEESTO;
               ELSE
                  IF V_QTDEANTE <> 0 THEN
                     V_CUSTPROD := V_VRBRUANT / V_QTDEANTE;
                  END IF;
               END IF;

               IF (V_VALRBRUT - (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOBRUT)) >= 0 THEN
                  V_VALRBRUT     := V_VALRBRUT - (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOBRUT);
                  P_VRCUSTLANCBR := C_LANCTOEST.QTLANCTOEST * C_LANCTOEST.VRLANCTOBRUT;
               ELSE
                  V_VALRBRUT     := V_VALRBRUT - (C_LANCTOEST.QTLANCTOEST * V_CUSTPROD);
                  P_VRCUSTLANCBR := C_LANCTOEST.QTLANCTOEST * V_CUSTPROD;
               END IF;
               /*Liquido*/
               V_CUSTPROD := 0;
               IF V_QTDEESTO <> 0 THEN
                  V_CUSTPROD := V_VALRESTO / V_QTDEESTO;
               ELSE
                  IF V_QTDEANTE <> 0 THEN
                     V_CUSTPROD := V_VRESTANT / V_QTDEANTE;
                  END IF;
               END IF;

               IF (V_VALRESTO - (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOEST)) >= 0 THEN
                  V_VALRESTO     := V_VALRESTO - (C_LANCTOEST.QTLANCTOEST*C_LANCTOEST.VRLANCTOEST);
                  P_VRCUSTOLANC  := C_LANCTOEST.QTLANCTOEST * C_LANCTOEST.VRLANCTOEST;
               ELSE
                  V_VALRESTO     := V_VALRESTO - (C_LANCTOEST.QTLANCTOEST*V_CUSTPROD);
                  P_VRCUSTOLANC  := C_LANCTOEST.QTLANCTOEST * V_CUSTPROD;
               END IF;
            END IF;

            V_QTDEESTO := V_QTDEESTO - C_LANCTOEST.QTLANCTOEST;

            IF ROUND(V_QTDEESTO,3) = 0 THEN
               V_QTDEESTO := 0;
            END IF;

            IF V_QTDEESTO  = 0 THEN
               V_VALRBRUT   := 0;
               V_VALRESTO   := 0;
            END IF;

            P_QTDELANCTO   := C_LANCTOEST.QTLANCTOEST;
         END IF;

         /* GUARDA OS VALORES DE ESTOQUE ANTERIORES  PRXIMA MOVIMENTAO */
         V_QTDEESTOPOS   := V_QTDEESTO;
         V_VALRESTOPOS   := V_VALRESTO;
         V_VALRBRUTPOS   := V_VALRBRUT;
         V_QTDEANTEPOS   := V_QTDEANTE;
         V_VRESTANTPOS   := V_VRESTANT;
         V_VRBRUANTPOS   := V_VRBRUANT;

         IF C_LANCTOEST.IDTIPOMOVI  = P_IDTIPOMOVI  THEN
            EXIT;
         END IF;
      END LOOP;
   END;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CUSTO_LANCAMENTO','6.49.046'); END;
/

